program I2C_COM2;
{Programm steuert ber die serielle Schnittstelle COM 2}
{den I2C Port mit der Schaltung}
{Stromversorgung der Chipkarte ueber TxD}
{CTS ist SDAin  DTR ist SDAout  RTS ist SCL}
uses
DOS,CRT;
const
                        BA = $2F8;
var
heze,heei,ein,adr,zahl,spalt            : byte;
Histr,      Hexastr                     : string;
eingabe,hwt,nwt                         : char;

procedure I2C_Init;
begin
  Port [BA+4] := 3;
  Delay(10);
end;
procedure Start;
begin
  Port [BA+4] := 2;
  Delay(10);
  Port [BA+4] := 0;
  Delay(10);
end;
procedure Stop;
begin
  Port [BA+4] := 0;
  Delay(10);
  Port [BA+4] := 2;
  Delay(10);
  Port [BA+4] := 3;
  Delay(10);
end;
procedure Acknowledge;
var m : word;
begin
  Port [BA+4] := 0;
  Delay(10);
  Port [BA+4] := 2;
  Delay(10);
  for m := 1 to 100 do;
  Port [BA+4] := 0;
  Delay(10);
end;
procedure KeinAcknowledge;
var m : word;
begin
  Port [BA+4] := 1;
  Delay(10);
  Port [BA+4] := 3;
  for m := 1 to 100 do;
  Port [BA+4] := 1;
end;
procedure Ausgeben (Wert : Byte);
var Bitwert, Portwert, n : Byte;
    m                    : Word;
begin
  Bitwert := 128;
  for n:= 1 to 8 do begin
    if (Wert and Bitwert) = Bitwert then Portwert := 1 else
       Portwert := 0;
    Port [BA+4] := Portwert ;
    Delay(10);
    Port [BA+4] := Portwert + 2;
    Delay(10);
  for m := 1 to 100 do;
    Delay(1);
    Port [BA+4] := Portwert;
    Bitwert := Bitwert div 2;
  end;
  Port [BA+4] := 1;
  Delay(10);
  Port [BA+4] := 3;
  Delay(10);
  for m := 1 to 100 do;
  Delay(1);
  if (Port[BA+6] AND 16) = 16 then writeln ('IC antwortet nicht');
  Port [BA+4] := 1;
  Delay(10);
end;

function Einlesen : Byte;
var Bitwert, Wert, n  : byte;
    m                  : word;
begin
  Port [BA+4] := 1;
  DElay(10);
  Bitwert := 128;
  Wert := 0;
  for n:= 1 to 8 do begin
    Port [BA+4] := 3;
    Delay(10);
    for m := 1 to 100 do
    Delay(1);
    if (Port [BA+6] AND 16) = 16 then Wert := Wert + Bitwert;
    Port [BA+4] := 1;
    Delay(10);
    Bitwert := Bitwert div 2;
  end;
  Einlesen := Wert;
end;

procedure wand;
begin
Hexastr :='';
Histr :='';
heei := zahl mod 16;
heze := zahl div 16;
if heze >= 10 then Hexastr := CHR(heze+55) else Hexastr := CHR(heze+48);
if heei >= 10 then Histr := CHR(heei+55) else Histr := CHR(heei+48);
Hexastr := Hexastr + Histr;
end;

procedure speichern;
    begin
    start;
    Ausgeben($0A0);
    Ausgeben(adr);
    Ausgeben (zahl);
    Acknowledge;
    stop;
    Delay(3000);
    end;

procedure adresseingabe;
   begin
     hwt := readkey;
     write (hwt);
     nwt := readkey;
     write (nwt);
     writeln ;
     heze := ord(hwt)-48;
     heei := ord(nwt)-48;
     if heze > 48 then heze := heze - 39;
     if heze > 16 then heze := heze - 7;
     if heei > 48 then heei := heei - 39;
     if heei > 16 then heei := heei - 7;
     zahl := 16 * heze +heei;
   end;

procedure schreiben;
   begin
      ClrScr;
      GotoXY(1,10);
      write(' Geben Sie die Adresse von 00 ... FF hexadezimal ein : ');
      adresseingabe;
      adr := zahl;
      GotoXY(1,15);
      write(' Geben Sie den Speicherwert 00 ... FF hexadezimal ein : ');
      adresseingabe;
      speichern;
   end;

procedure dump;
    begin
  ClrScr;
  for adr := 0 to 255 do
 begin
   Start;
   Ausgeben($0A0);
   Ausgeben(Adr);
   Acknowledge;
   Stop;
   Start;
   Ausgeben($0A1);
   ein:= Einlesen;
   Stop;
   if Adr div 8 = Adr/8 then
   begin
     zahl := adr;
     wand;
     Writeln;
     Write('Adresse ',Hexastr,': ');
   end;
   zahl := ein;
   wand;
   Write(Hexastr);
   Write(' ');
   spalt := whereX;
   GotoXY(spalt + 30,WhereY);
     case ein of
        00  : write('.');
        07  : write('.');
        10  : write('.');
        32  : write('.');
       255  : write('.');
     else
     Write (chr(ein));
    end;
   GotoXY(spalt,whereY);
   end;
   repeat;
   Delay(30);
   until keypressed;
   end;

begin
 repeat
 I2C_Init;
 port[BA+3]:= 64;
 ClrScr;
 Delay(5000);
 Textmode(CO80);
 GoToXY(10,1);
 Writeln('C h i p k a r t e n - L e s e / S c h r e i b p r o g r a m m ');
 GotoXY(12,6);
 Writeln('von Dipl.-Ing. Andreas Koehler     Dessau       2001');
 GoToXY(10,11);
 Writeln('Lesen der Chipkarte mit "L"  Schreiben der Chipkarte mit "S" ');
 GoToXY(20,16);
 Writeln('Weiter mit Taste  (L)esen oder (S)chreiben ');
 GoToXY(20,21);
 Writeln('Abbruch mit der Taste "x" ');
  eingabe := readkey;
  case eingabe of
   'l'      : dump;
   'L'      : dump;
   'S'      : schreiben;
   's'      : schreiben;
   end;
   until eingabe  = 'x';
end.


